;; minigroup2.scm
;; This creates a group textarea after it prompts the user for some information

;; Use:
;; java -cp lib/jscheme.jar:java jscheme.REPL tat/minigroup.scm "(go NAME 'green \"cleo.cs.brandeis.edu\" 14341)"

;; create group client connected to fixed group server
;; create group textarea and go
(jlib.Swing.load)
(load "tat/Networking.scm")
(load "tat/GroupTA.scm")
(load "newtat/RegWin.scm")

(define Reg 
   (make-reg-win "Registration for Group Edit Window" 
      '(
        ("USER NAME" "guest") 
        (COLOR green)
        ("start a group server" (no yes))
        (server "localhost") 
        (port 14341) 
        ("group name" "guestroom"))
       (lambda (name color startserver server port group)
          (if (equal? startserver "yes") (make-group-server (Integer. port)))
          (go name group color server (Integer. port)))))

(define (go name group mycolor server port)
  (let* 
      ((G (make-group-client name group server port))
       (w (window name
            (both-textarea G "workspace" mycolor 10 50))))
    (.pack w)
    (.show w)
     w))

(.show (Reg 'get 'window))
