

  (define (connect host/db user pw) 
    (let* ((d (org.gjt.mm.mysql.Driver.)))
       (java.sql.DriverManager.getConnection host/db user pw)))

  (define (handle-query con query)
    (let* ((stmt (.createStatement con))
           (rs (.executeQuery stmt query))
           (rsmd (.getMetaData rs))
           (cols (.getColumnCount rsmd))
           (result
             (if (= cols 0) '("No results for this query.")
              (cons
                (let loop1 ((i 1))
                  (if (> i cols) ()
                      (cons (.getColumnLabel rsmd i) 
                            (loop1 (+ i 1)))))
                (let loop ()
                   (if (not (.next rs)) ()
                       (cons
                          (let innerloop ((i 1))
                              (if (> i cols) ()
                                  (cons (.getString rs i) 
                                        (innerloop (+ i 1)))))
                          (loop))))))))
        (map .close (list rs stmt))
       result))

  (define (run-query host/db user pw query)
    (define con (connect host/db user pw))
    (define result (handle-query con query))
    (.close con)
    result)




(define (test-registrar debug)
  (define Server (list "localhost" 23232))
  (define M (make-servent 0))
  (define (P) (set! P (make-servent 0)))
  (define (Q) (set! Q (make-servent 0)))
  (define N (go))


  (if debug  (begin
       (N 'add-super-listener (lambda R (display (list 'system R (java.util.Date.))) (newline)))
       (M 'add-super-listener (lambda R (display (list 'user R (java.util.Date.))) (newline)))   ))


  (M 'add-listener 'are-you-there (lambda R
      (M 'send Server 'i-am-here 'tim)))


  (java.lang.Thread.sleep 1000L)

  (M 'send Server 'login 'tim 'thanks (M 'get 'address))
  (M 'send Server 'lookup-all 'tim 'thanks)

  (P)
  (P 'add-listener 'are-you-there (lambda R
      (P 'send Server 'i-am-here 'jj)))
  (P 'send Server 'login 'jj 'thanks (P 'get 'address))
  (java.lang.Thread.sleep 2000L)
  (M 'send Server 'lookup-all 'tim 'thanks)

  (Q)
  (Q 'add-listener 'are-you-there (lambda R
      (Q 'send Server 'i-am-here 'kk)))
  (Q 'send Server 'login 'kk 'thanks (Q 'get 'address))
  (java.lang.Thread.sleep 2000L)
  (M 'send Server 'lookup-all 'tim 'thanks)

  (java.lang.Thread.sleep 2000L)
  (M 'send Server 'lookup 'jj 'tim 'thanks)

  (java.lang.Thread.sleep 2000L)
  (P 'send Server 'logout 'jj 'thanks)
  (Q 'send Server 'logout 'kk 'thanks)

  (java.lang.Thread.sleep 2000L)
  (M 'send Server 'logout 'tim 'thanks)

  (java.lang.Thread.sleep 1000L)
  (N 'logout)
  (display 'done)(newline)(newline)

)


(define (cs2a-auth dbpw)
  ;; this gets the username from a string by removing the -XXXX suffix if there is one
  (define (getusername S)
    (let ((z (.indexOf S "-")))
      (if (equal? z -1) S (.substring S 0 z))))
  (lambda (user password)
  (let* (
   (dbhostport  "jdbc:mysql://odysseus.cs.brandeis.edu:3306/cs2a01")
   (dbuser  "cs2a01")
   (query
     (string-append "select password from pseudo where  unetid='" (getusername user) "';"))
   (result
    (run-query dbhostport dbuser dbpw query)))
  (equal? (first (second result)) (.toString password)))))


(define (test2 pw)
  (define N (start-registrar 23232 (cs2a-auth pw)))
  (define M (make-servent 0))
  (define Server (list "localhost" 23232))
  (M 'add-super-listener (lambda R
    (display R) (newline)(newline)))
  (M 'send Server 'login 'tjhickey 'ahha (M 'get 'address))
  (M 'send Server 'lookup-all 'tjhickey 'ahha)
  (java.lang.Thread.sleep 1000L)
  (M 'logout 'tjhickey 'ahha)
  (display 'done)(newline)
)



