;; P2Pchat.scm
;;   (p2p-chat-panel N MyName User/Address)  ;; User/Address has form '(name (ipadd port))
;; this creates a chat panel which uses the servnet N to communicate with the
;; user at User/Address. It tags all message from self with "MyName"
;;
;; It would be nice to extend this to a group chat model where everyone subscribes to a
;; group-server. I'll work on this later.
;; It would also be nice to have this return an object which could be retargeted to
;; other chat groups, etc....


   (define (p2p-chat-panel N MyName User/Address)  ;; User/Address has form '(name (ipadd port))
      (define jnk4 (begin (display "abc4")(newline)))
      (define (update-scroller)
        (let* ((vp (.getViewport (tt "chatscroll")))
               (size (.getViewSize vp))
               (p (java.awt.Point. 0 (.intValue(.getHeight size)))))
         (.setViewPosition vp p)
         (.validate (tt "chatscroll"))))

      (define tt (maketagger))
      (define me MyName)
      (define inchannel (string-append "" (first User/Address)))
      (define outchannel (string-append "" me))
      (define chat-listener  (lambda R
	    (begin
;              (display (list "in listener: " R))(newline)
	          (.append (tt "chatarea") (string-append (first R) ": " (second R) "\n"))
             (update-scroller))))
	    
      (define conversation "")

      (define the-panel
        (border
          (north (label "Peer-to-peer chat" (HelveticaBold 24)))
          (center
           (tt "chatscroll" (scrollpane
            (tt "chatarea" (javax.swing.JTextArea. 10 50)))))
          (south
           (border 
             (west (label ">>"))
             (center
              (tt "chatline" (textfield "" 1 (action (lambda(e)			       
                (.append (tt "chatarea") 
                       (string-append MyName ": " (readstring (tt "chatline"))
                             "\n==================================================\n\n"))

                (N 'send (second User/Address) outchannel (readstring (tt "chatline")))
                (writestring (tt "chatline") "")
              )))))))))
      (define jnk5 (begin (display "abc5")(newline)))
      (.setEditable (tt "chatarea") #f)
      (.setBackground (tt "chatarea") remotecolor)
      (N 'add-listener inchannel chat-listener)
      (display (list "panel is complete"))(newline)
      the-panel)
        








