
import javax.swing.*; 
import java.awt.*; 
import java.awt.event.*; 
import java.util.*; 
public class LoggingQueue extends EventQueue { 
    protected Vector eventLog = new Vector(); 
    protected void dispatchEvent(AWTEvent event) 
    { 
	eventLog.addElement(event.toString()); 
	System.out.println(event.toString()); 
	super.dispatchEvent(event); 
    } 
    public static void main(String[] args) 
    { 
	JFrame frame = new JFrame(); 
	frame.getToolkit().getSystemEventQueue(
               ).push(new LoggingQueue()); 
	frame.setSize(300,300); 
	frame.setVisible(true); 
    } 
} 
