(jlib.Swing.load)

(define (htmlpane data-type first-data)
  (define HtmlPane (javax.swing.JEditorPane.))
  (define history ())
  (define future ())
  (define HtmlComponent
     (border
      (center
        (scrollpane  HtmlPane))
      (south
        (row 'none 'center
          (button "back" (action (lambda(e) 
           (display (list "history=" history "future=" future))(newline)
           (if (null? (rest history)) #t
	       (tryCatch
            (begin
             (set! future (cons (first history) future))
             (set! history (cdr history))
             (.setPage HtmlPane (first history)))
            
	                      (lambda(t)
                    (.printStackTrace t)))
))))
          (button "forward" (action (lambda(e) 
           (display (list "history=" history "future=" future))(newline)
            (if (null? future) #t
		(tryCatch
		(begin
		  (set! history (cons (first future) history))
		  (set! future (cdr future))
		  (.setPage HtmlPane (first history))
		                  ) (lambda(t)
                    (.printStackTrace t)))
))))))))
  

  
  
  ;; we don't really understand this, we just copied and transcribed from Sun's stuff.....
  (.addHyperlinkListener HtmlPane 
  (Listener. (lambda(e)
    (if (equal? (.getEventType e) javax.swing.event.HyperlinkEvent$EventType.ACTIVATED$)
        (let ((pane (.getSource e)))
          (if (.isInstance javax.swing.text.html.HTMLFrameHyperlinkEvent.class e)
             (begin (display "A wins")(newline)
              (let ((doc (.getDocument pane)))
                 (.processHTMLFrameHyperlinkEvent doc e)))
             (begin (display "B wins") (newline)
              (tryCatch
                 (begin
                   (set! history (cons (.getURL e) history))
                   (set! future ())
                   (.setPage pane (.getURL e)))
                 (lambda(t)
                    (.printStackTrace t))))))))))


  (tryCatch
      (if (equal? data-type 'url)
          (begin
             (.setPage HtmlPane (java.net.URL. first-data))
             (set! history (list first-data)))
          (begin
             (.setContentType HtmlPane "text/html")
             (.setText HtmlPane first-data)
             (set! history (list ))))
     (lambda(e) 
          (display (list "couldn't form url:" e))(newline)))

   (.setEditable HtmlPane #f)
   ;get ready and show the page
   HtmlComponent
)


(define (r) (load "HtmlFrame.scm"))



